## org.springframework.scheduling.concurrent
Class ThreadPoolExecutorFactoryBean

    java.lang.Object
      org.springframework.util.CustomizableThreadCreator
          org.springframework.scheduling.concurrent.CustomizableThreadFactory
              org.springframework.scheduling.concurrent.ExecutorConfigurationSupport
                  org.springframework.scheduling.concurrent.ThreadPoolExecutorFactoryBean

All Implemented Interfaces:
  Serializable, ThreadFactory, BeanNameAware, DisposableBean, FactoryBean<ExecutorService>, InitializingBean

    public class ThreadPoolExecutorFactoryBean

extends ExecutorConfigurationSupport
implements FactoryBean<ExecutorService>, InitializingBean, DisposableBean

JavaBean that allows for configuring a JDK 1.5 `ThreadPoolExecutor` in bean style (through its "corePoolSize", "maxPoolSize", "keepAliveSeconds", "queueCapacity" properties) and exposing it as a bean reference of its native `ExecutorService` type.

For an alternative, you may set up a ThreadPoolExecutor instance directly using constructor injection, or use a factory method definition that points to the JDK 1.5 `Executors` class.

If you need a timing-based `ScheduledExecutorService` instead, consider `ScheduledExecutorFactoryBean`.

Since:
  3.0
Author:
  Juergen Hoeller
See Also:
  `ExecutorService`, `Executors`, `ThreadPoolExecutor`, Serialized Form

Field Summary

Fields inherited from class org.springframework.scheduling.concurrent.ExecutorConfigurationSupport
`logger`

Constructor Summary
`ThreadPoolExecutorFactoryBean()`

Method Summary
`protected BlockingQueue<Runnable>` `createQueue(int queueCapacity)` Create the BlockingQueue to use for the ThreadPoolExecutor.
`ExecutorService` `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class<? extends ExecutorService>` `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`protected ExecutorService` `initializeExecutor(ThreadFactory threadFactory, RejectedExecutionHandler rejectedExecutionHandler)` Create the target `ExecutorService` instance.
`boolean` `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` `setAllowCoreThreadTimeOut(boolean allowCoreThreadTimeOut)` Specify whether to allow core threads to time out.
`void` `setCorePoolSize(int corePoolSize)` Set the ThreadPoolExecutor's core pool size.
`void` `setExposeUnconfigurableExecutor(boolean exposeUnconfigurableExecutor)` Specify whether this FactoryBean should expose an unconfigurable decorator for the created executor.
`void` `setKeepAliveSeconds(int keepAliveSeconds)` Set the ThreadPoolExecutor's keep-alive seconds.
`void` `setMaxPoolSize(int maxPoolSize)` Set the ThreadPoolExecutor's maximum pool size.
`void` `setQueueCapacity(int queueCapacity)` Set the capacity for the ThreadPoolExecutor's BlockingQueue.

Methods inherited from class org.springframework.scheduling.concurrent.ExecutorConfigurationSupport
`afterPropertiesSet, destroy, initialize, setBeanName, setRejectedExecutionHandler, setThreadFactory, setThreadNamePrefix, setWaitForTasksToCompleteOnShutdown, shutdown`

Methods inherited from class org.springframework.scheduling.concurrent.CustomizableThreadFactory
`newThread`

Methods inherited from class org.springframework.util.CustomizableThreadCreator
`createThread, getDefaultThreadNamePrefix, getThreadGroup, getThreadNamePrefix, getThreadPriority, isDaemon, nextThreadName, setDaemon, setThreadGroup, setThreadGroupName, setThreadPriority`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.springframework.beans.factory.InitializingBean
`afterPropertiesSet`

Methods inherited from interface org.springframework.beans.factory.DisposableBean
`destroy`

Constructor Detail

### ThreadPoolExecutorFactoryBean

    public ThreadPoolExecutorFactoryBean()

Method Detail

### setCorePoolSize

    public void setCorePoolSize(int corePoolSize)

  Set the ThreadPoolExecutor's core pool size. Default is 1.

  This setting can be modified at runtime, for example through JMX.

### setMaxPoolSize

    public void setMaxPoolSize(int maxPoolSize)

  Set the ThreadPoolExecutor's maximum pool size. Default is `Integer.MAX_VALUE`.

  This setting can be modified at runtime, for example through JMX.

### setKeepAliveSeconds

    public void setKeepAliveSeconds(int keepAliveSeconds)

  Set the ThreadPoolExecutor's keep-alive seconds. Default is 60.

  This setting can be modified at runtime, for example through JMX.

### setAllowCoreThreadTimeOut

    public void setAllowCoreThreadTimeOut(boolean allowCoreThreadTimeOut)

  Specify whether to allow core threads to time out. This enables dynamic growing and shrinking even in combination with a non-zero queue (since the max pool size will only grow once the queue is full).

  Default is "false". Note that this feature is only available on Java 6 or above. On Java 5, consider switching to the backport-concurrent version of ThreadPoolTaskExecutor which also supports this feature.

  See Also:
    `ThreadPoolExecutor.allowCoreThreadTimeOut(boolean)`

### setQueueCapacity

    public void setQueueCapacity(int queueCapacity)

  Set the capacity for the ThreadPoolExecutor's BlockingQueue. Default is `Integer.MAX_VALUE`.

  Any positive value will lead to a LinkedBlockingQueue instance; any other value will lead to a SynchronousQueue instance.

  See Also:
    `LinkedBlockingQueue`, `SynchronousQueue`

### setExposeUnconfigurableExecutor

    public void setExposeUnconfigurableExecutor(boolean exposeUnconfigurableExecutor)

  Specify whether this FactoryBean should expose an unconfigurable decorator for the created executor.

  Default is "false", exposing the raw executor as bean reference. Switch this flag to "true" to strictly prevent clients from modifying the executor's configuration.

  See Also:
    `Executors.unconfigurableScheduledExecutorService(java.util.concurrent.ScheduledExecutorService)`

### initializeExecutor

    protected ExecutorService initializeExecutor(ThreadFactory threadFactory,
                                                 RejectedExecutionHandler rejectedExecutionHandler)

  Description copied from class: `ExecutorConfigurationSupport`
  Create the target `ExecutorService` instance. Called by `afterPropertiesSet`.

  Specified by:
    `initializeExecutor` in class `ExecutorConfigurationSupport`
  Parameters:
    `threadFactory` - the ThreadFactory to use
    `rejectedExecutionHandler` - the RejectedExecutionHandler to use
  Returns:
    a new ExecutorService instance
  See Also:
    `ExecutorConfigurationSupport.afterPropertiesSet()`

### createQueue

    protected BlockingQueue<Runnable> createQueue(int queueCapacity)

  Create the BlockingQueue to use for the ThreadPoolExecutor.

  A LinkedBlockingQueue instance will be created for a positive capacity value; a SynchronousQueue else.

  Parameters:
    `queueCapacity` - the specified queue capacity
  Returns:
    the BlockingQueue instance
  See Also:
    `LinkedBlockingQueue`, `SynchronousQueue`

### getObject

    public ExecutorService getObject()
                              throws Exception

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean<ExecutorService>`
  Returns:
    an instance of the bean (can be `null`)
  Throws:
    `Exception` - in case of creation errors
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class<? extends ExecutorService> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<ExecutorService>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<ExecutorService>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`